package org.dromara.work.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.work.domain.bo.TpPanoramaBo;
import org.dromara.work.domain.vo.TpPanoramaVo;
import org.dromara.work.domain.TpPanorama;
import org.dromara.work.mapper.TpPanoramaMapper;
import org.dromara.work.service.ITpPanoramaService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 全景Service业务层处理
 *
 * @author Maosw
 * @date 2025-03-26
 */
@RequiredArgsConstructor
@Service
public class TpPanoramaServiceImpl implements ITpPanoramaService {

    private final TpPanoramaMapper baseMapper;

    /**
     * 查询全景
     *
     * @param id 主键
     * @return 全景
     */
    @Override
    public TpPanoramaVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询全景列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 全景分页列表
     */
    @Override
    public TableDataInfo<TpPanoramaVo> queryPageList(TpPanoramaBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpPanorama> lqw = buildQueryWrapper(bo);
        Page<TpPanoramaVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        lqw.orderByDesc(TpPanorama::getCreateTime);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的全景列表
     *
     * @param bo 查询条件
     * @return 全景列表
     */
    @Override
    public List<TpPanoramaVo> queryList(TpPanoramaBo bo) {
        LambdaQueryWrapper<TpPanorama> lqw = buildQueryWrapper(bo);
        lqw.orderByAsc(TpPanorama::getSort, TpPanorama::getCreateTime);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpPanorama> buildQueryWrapper(TpPanoramaBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TpPanorama> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getOrderId() != null, TpPanorama::getOrderId, bo.getOrderId());
        lqw.like(StringUtils.isNotBlank(bo.getTitle()), TpPanorama::getTitle, bo.getTitle());
        lqw.eq(bo.getSort() != null, TpPanorama::getSort, bo.getSort());
        lqw.between(params.get("beginCreateTime") != null && params.get("endCreateTime") != null,
            TpPanorama::getCreateTime ,params.get("beginCreateTime"), params.get("endCreateTime"));
        return lqw;
    }

    /**
     * 新增全景
     *
     * @param bo 全景
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpPanoramaBo bo) {
        TpPanorama add = MapstructUtils.convert(bo, TpPanorama.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改全景
     *
     * @param bo 全景
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpPanoramaBo bo) {
        TpPanorama update = MapstructUtils.convert(bo, TpPanorama.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TpPanorama entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除全景信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
